Subject: bug#12419: Mouse click changes layout

From: "Drew Adams" <[email-masked]>
Date: Fri, 14 Sep 2012 09:18:04 -0700

>  >> When dragging a divider, windows are resized asymmetrically,
>  >> that is we enlarge only the window we drag away from and
>  >> shrink the windows on the other side.
>  >
>  > That sounds normal, but what is the alternative - how 
>  > could it be otherwise?
> 
> That all windows on the other side get resized proportionally.

How is that different from "shrink the windows on the other side"?  I'm guessing
that shrink them, but not proportionately?

>  >> Asymmetric resizing is not reversible, that is, dragging the
>  >> divider back by the same amount will not necessarily reproduce the
>  >> inital configuration.
>  >
>  > I don't think that is what I see.  But I guess I don't 
>  > understand what you're saying.  Can you give an example,
>  > and contrast what happens in earlier Emacs releases?
> 
> Try with three windows above each other and drag one
> modeline until both windows in the direction you drag to
> are at their minimum height.  Then drag the divider back.
> The outermost window is not sized back.

I see.  In previous releases when you drag one mode line, only the adjacent
window shrinks.  And that corresponds exactly (AFAICT) to the opposite action of
dragging the mode line back again.  So previously the opposite drag action was
symmetric to the initial drag action.  Now it is not.

Can we (and then should we) make this change in behavior optional (for the
user)?

> Now set `resize-mini-windows' to nil and drag the bottom modeline.  
> All windows get resized proportionally in both directions.

Not with a standalone minibuffer frame.  At least I see no change in behavior,
whatever the value of `resize-mini-windows'.

> In Emacs 23.3 automatically resizing the minibuffer resizes the lowest
> window first.  That's what people want.  But IIRC this 
> doesn't work with `resize-mini-windows' t and `resize-mini-windows'
> nil doesn't work when the lowest window is at its minimum height.

OK, thanks for the explanation.

Consider proposing something for emacs-devel to discuss.  Was the change in
behavior from Emacs 23 to 24 (the change made so far) ever discussed?

Personally I don't care much, since I don't split windows that much.  But this
sounds like something that affects lots of users, and perhaps there should be
some discussion about it.